import * as log from "tauri-plugin-log-api";

const methods = ["trace", "debug", "info", "warn", "error"] as const;
type Logger = {
  [key in (typeof methods)[number]]: (
    message: string,
    options?: log.LogOptions
  ) => Promise<void>;
};

function createLogger() {
  const logger: Logger = {} as Logger;
  for (const method of methods) {
    logger[method] = async (message, options) => {
      console[method](message);
      await log[method](message, options);
    };
  }
  return logger;
}

export default createLogger();
